/*
 * Copyright(C) 2000-2006  
 *
 *    , 
 *   -.
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *     -.
 */

#ifndef _DESCRYPTEX_H_INCLUDED
#define _DESCRYPTEX_H_INCLUDED


#define ALG_SID_UECMASTER_DIVERS		47


#define ALG_SID_UECDIVERS			44
#define ALG_SID_UECSYMMETRIC			46
#define ALG_SID_UECSYMMETRIC_EPHEM		47

#define ALG_CLASS_UECSYMMETRIC                (6 << 13)

#define	ALG_SID_SHA_224				0x11d

#define AT_UECSYMMETRICKEY		   0x80000004

 //CALG_GR3411_UECMASTER
#define CALG_UECMASTER_DIVERS \
    (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_UECMASTER_DIVERS)

#define CALG_UECSYMMETRIC \
    (ALG_CLASS_UECSYMMETRIC | ALG_TYPE_BLOCK | ALG_SID_UECSYMMETRIC)
#define CALG_UECSYMMETRIC_EPHEM \
    (ALG_CLASS_UECSYMMETRIC | ALG_TYPE_BLOCK | ALG_SID_UECSYMMETRIC_EPHEM)

#define CALG_SHAREDKEY_HASH \
    (ALG_CLASS_HASH | ALG_TYPE_SHAREDKEY | ALG_SID_SHAREDKEY_HASH)
#define CALG_FITTINGKEY_HASH \
    (ALG_CLASS_HASH | ALG_TYPE_SHAREDKEY | ALG_SID_FITTINGKEY_HASH)

#define CALG_SHA_224 \
    (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_SHA_224)

#define HP_SHAREDKEYMODE 0x0012
#define HP_SHAREDKEYALGID 0x0013

#define SYMMETRICKEYBLOB    0xC

//defines from rsaenh/include/wincrypt.h
#define ALG_SID_GENERIC_SECRET         21
#define CKM_EXTRACT_KEY_FROM_KEY        0xE
#define CKM_DES_ENCRYPT_DATA            0xF
#define CKM_CONCATENATE_BASE_AND_KEY    0x2
#define CKM_CONCATENATE_BASE_AND_DATA   0x3
#define CKM_CONCATENATE_DATA_AND_BASE   0x4
#define CKM_XOR_BASE_AND_DATA           0x5
#define CALG_GENERIC_SECRET       (ALG_CLASS_DATA_ENCRYPT | ALG_TYPE_BLOCK         | ALG_SID_GENERIC_SECRET)
#define KP_START_DATE                   43
#define KP_END_DATE                     44
#define KP_UEC_DERIVE_COUNTER           45
#define KP_HANDLE	                46

#define CKM_UEC_EXTRACT_KEY_FROM_RSA    0x0

//defines from PKCS11 for UEC
#define CKA_MODULUS            0x00000120
#define CKA_PUBLIC_EXPONENT    0x00000122
#define CKA_PRIVATE_EXPONENT   0x00000123
#define CKA_PRIME_1            0x00000124
#define CKA_PRIME_2            0x00000125
#define CKA_EXPONENT_1         0x00000126
#define CKA_EXPONENT_2         0x00000127
#define CKA_COEFFICIENT        0x00000128
#define CKA_PRIME              0x00000130

/* Blob Types */
#define SIMPLEBLOB                      0x1
#define PUBLICKEYBLOB                   0x6
#define PRIVATEKEYBLOB                  0x7
#define PLAINTEXTKEYBLOB                0x8
#define OPAQUEKEYBLOB                   0x9
#define PUBLICKEYBLOBEX                 0xA
#define SYMMETRICWRAPKEYBLOB            0xB
#define SYMMETRICKEYBLOB                0xC
#define GOSTEXPORTKEYBLOB               0xD
#define RSA_CKM_EXTRACT_KEY_FROM_KEY        0xE
#define RSA_CKM_DES_ENCRYPT_DATA            0xF
#define RSA_CKM_CONCATENATE_BASE_AND_KEY    0x2
#define RSA_CKM_CONCATENATE_BASE_AND_DATA   0x3
#define RSA_CKM_CONCATENATE_DATA_AND_BASE   0x4
#define RSA_CKM_XOR_BASE_AND_DATA           0x5
#define RSA_CKM_UEC_EXTRACT_KEY_FROM_RSA    0x10
#define RSA_CKM_SHA1_KEY_DERIVATION         0x11

#define PKCS1KEYBLOB			    0x18
#define PKCS8KEYBLOB			    0x19

#define CRYPT_ENCRYPT_KEY		    0x0040
/*   RSA */
#define CRYPT_RSA_PKCS			    0x00000050 //  
#define CRYPT_RSA_X_509			    0x00000051

#define ALG_SID_AT_DES                 18
#define ALG_SID_AT_3DES                19
#define ALG_SID_AT_3DES_112            20
#define ALG_SID_GENERIC_SECRET         21

#define AT_UECSYMMETRICKEY		   0x80000004

#define CALG_AT_DES               (ALG_CLASS_DATA_ENCRYPT | ALG_TYPE_BLOCK         | ALG_SID_AT_DES)
#define CALG_AT_3DES              (ALG_CLASS_DATA_ENCRYPT | ALG_TYPE_BLOCK         | ALG_SID_AT_3DES)
#define CALG_AT_3DES_112          (ALG_CLASS_DATA_ENCRYPT | ALG_TYPE_BLOCK         | ALG_SID_AT_3DES_112)

#define PP_GOST_PROV_NAME 146
#define PP_PUBLIC_EXPONENT 147
#define CRYPT_TO_RSA  0x10000
#define CRYPT_TO_GOST 0x20000
#define GR3410_1_MAGIC 0x3147414D

#define DEFAULT_PUBLIC_EXPONENT	    65537

/* ,        ,
   ,   WinCryptEx.h*/
#define CRYPT_FILTER_PROVIDER_TYPE 0x100

#define HP_HASHVAL_BLOB	    0x0021

#endif /* _DESCRYPTEX_H_INCLUDED */
