/*
 * Copyright(C) 2003  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 126987 $
 * \date $Date:: 2015-09-08 17:51:58 +0400#$
 * \author $Author: pav $
 *
 * \brief CertificateInfo class
 */

#ifndef CA_CMP_CERIFICATE_H
#define CA_CMP_CERIFICATE_H

#include "CA_CMP_Types.h"
#include "CA_CMP_Msg.h"

/**************************************************************/
/*                                                            */
/*  Internal structure                                        */
/*                                                            */
/**************************************************************/

class CertificateTemplate;

class CertificateInfo : public PKIXCMP_Message
{
public:
    friend class PKIXCMP_Server;
    friend class PKIXCMP_Client;

    // Init by zero
    CertificateInfo();
    ~CertificateInfo();

    //  
    int RequestID;
    
    int Status;

    //   ,   Subject (  ASN1T_Name.ASN1T_RDNSequence)
    // ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Name subject
    CACMPT_PARSED_RDN subjectRDN;

    //   ,   Issuer (  ASN1T_Name.ASN1T_RDNSequence)
    // ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Name issuer
    CACMPT_PARSED_RDN issuerRDN;
    
    //  -	ASN1T_Certificate
    CACMPT_BLOB RawCertificate;
    
    //  - 	ASN1T_Certificate.ASN1TDynBitStr signature;
    CACMPT_BLOB CertificateSignature;
    
    //  -		ASN1T_Certificate.ASN1T_AlgorithmIdentifier signatureAlgorithm;
    char CertificateSignatureAlgorithm[ 254 ];
    
    //  - 	ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_CertificateSerialNumber serialNumber
    CACMPT_SERIAL SerialNumber;
    
    // Date -		ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Validity.ASN1T_Time notBefore
    CACMPT_Date NotBefore;
    	
    // Date -		ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Validity.ASN1T_Time notAfter
    CACMPT_Date NotAfter;

    // ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_SubjectPublicKeyInfo
    CACMPT_PublicKeyInfo	SubjectPublicKey;
    
    // ID -			ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_UniqueIdentifier issuerUniqueID
    int IssuerUniqueID;
    
    // ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Extensions extensions
    CACMPT_Extensions Extensions;
    
    //   
    CACMPT_BLOB SubjectKeyIdentifier;

    //   
    CACMPT_BLOB AuthorityKeyIdentifier;

    bool validity_changed;
protected:
    //  
    CertificateTemplate *preprocessed;

private:
    CertificateInfo(const CertificateInfo& c);
    CertificateInfo& operator=( const CertificateInfo& c );
};

#endif // CA_CMP_CERIFICATE_H
