#include <stdio.h>
#ifdef _WIN32
#   include <windows.h>
#   include <wincrypt.h>
#else
#   include <string.h>
#   include <stdlib.h>
#   include <CSP_WinDef.h>
#   include <CSP_WinCrypt.h>
#endif
#include <WinCryptEx.h>

//   (    ,   
//    )
//--------------------------------------------------------------------
//        .
//        EncryptedKeyBlob.enc.
//         
//      EncryptKey.
//       , 
//   "Sender.pub" (      
// ExportInFile). 
//       
//   ,     "vector.bin".
//    ,   "Sender"  "Responder", 
//    ExportInFile, EncryptKey  DecryptKey  
//    .
// :  win32   _s  CRT .
//--------------------------------------------------------------------

#ifdef _WIN32
#   define CONTAINER_COPY "\\\\.\\registry\\SenderCopy"
#else
#   define CONTAINER_COPY "\\\\.\\hdimage\\SenderCopy"
#endif
#define CONTAINER_COPY_PIN "111"

#pragma region  

#define BLOCK_LENGTH 4096

static void LoadPublicKey(BYTE *pbBlob, DWORD *pcbBlob, char *szCertFile, char *szKeyFile);
static void HandleError(char *s);
static void CleanUp(void);


static HCRYPTPROV hProv = 0;		//  CSP
static HCRYPTPROV hProvCopy = 0;        //   CSP     
static HCRYPTKEY hKey = 0;		//    
static HCRYPTKEY hKeyExport = 0;	//      AT_EXCHANGE
static HCRYPTKEY hAgreeKey = 0;        //   

static FILE *certf=NULL;		// ,    
static FILE *publicf=NULL;		// ,     
static FILE *vectorf=NULL;		//     
static FILE *EncryptedKeyBlob = NULL;   //     


//#define PROVIDER_NAME NULL
//#define PROVIDER_NAME "CP2001KC1"

#pragma endregion

#define MAX_PUBLICKEYBLOB_SIZE 200

int main(void)
{
    BYTE  pbKeyBlob[MAX_PUBLICKEYBLOB_SIZE];	//    BLOB 
    BYTE *pbKeyBlobExport = NULL;    //    BLOB   

    DWORD dwBlobLen = MAX_PUBLICKEYBLOB_SIZE;	//   BLOB
    DWORD dwKeyBlobExportLen;   //     
    //BYTE *pbKeyBlobSimple = NULL;  //     BLOB 
    //DWORD dwBlobLenSimple;	//    BLOB    
    
    BYTE pbIV[100];		//    
    DWORD dwIV = 0;		//   

    DWORD szf;

    ALG_ID ke_alg = CALG_PRO12_EXPORT; //   

    //  ,     .
    if(!(vectorf = fopen("vector.bin", "r+b")))
	HandleError( "Problem opening the file 'vector.bin'\n" );
    printf( "The file 'vector.bin' was opened\n" );

    //      .
    dwIV = (DWORD)fread(pbIV, 1, 100, vectorf);
    if(!dwIV)
	HandleError( "The IV can not be reading from the 'vector.bin'\n" );
    printf( "The IV was read from the 'vector.bin'\n" );
    
    //     
    if(!(EncryptedKeyBlob = fopen("EncryptedKeyBlob.enc", "r+b")))
	HandleError( "Problem opening the file 'EncryptedKeyBlob.enc'\n" );
    printf( "The file 'EncryptedKeyBlob.enc' was opened\n" );

    //------------------------------------------------------------------
    //    
    //------------------------------------------------------------------
    //    EncryptedKeyBlob.enc,    szfile
    fseek(EncryptedKeyBlob, 0, SEEK_END);
    szf = ftell(EncryptedKeyBlob);
    fseek(EncryptedKeyBlob, 0, SEEK_SET);
    
    //  
    pbKeyBlobExport = (BYTE*)malloc(szf);

    //       EncryptedKeyBlob.enc 
    dwKeyBlobExportLen = (DWORD)fread(pbKeyBlobExport, 1, szf, EncryptedKeyBlob);
    if(!dwKeyBlobExportLen)
	HandleError( "The private Key can not be reading from the 'EncryptedKeyBlob.enc'\n" );
    printf( "The private Key was read from the 'EncryptedKeyBlob.enc'\n" );


    //------------------------------------------------------------------
    //------------------------------------------------------------------
    //       "Responder", 
    //    . 
    if(!CryptAcquireContext(
	&hProv, 
	"Responder",
	NULL, 
	PROV_GOST_2012_256, 
	0)) 
    {
	HandleError("Error during CryptAcquireContext");
    }
    printf("The key container \"Responder\" has been acquired. \n");

    //       "ResponderCopy", 
    //     . 
    if(!CryptAcquireContext(
	&hProvCopy, 
	CONTAINER_COPY,
	NULL, 
	PROV_GOST_2012_256, 
	CRYPT_DELETEKEYSET | CRYPT_SILENT)) 
    {
	printf("ResponderCopy does not exist\n");
    }

    if(!CryptAcquireContext(
	&hProvCopy, 
	CONTAINER_COPY,
	NULL, 
	PROV_GOST_2012_256, 
	CRYPT_NEWKEYSET)) 
    {
	HandleError("Error during CryptAcquireContext");
    }

    if (!CryptSetProvParam(
	hProvCopy,
	PP_KEYEXCHANGE_PIN,
	(BYTE*)CONTAINER_COPY_PIN,
	0))
    {
	HandleError("Failed to set PIN");
    }

    printf("The key container \"ResponderCopy\" has been acquired. \n");


    //-----------------------------------------------------------------
    //   
    //-----------------------------------------------------------------
    //    
    LoadPublicKey(pbKeyBlob, &dwBlobLen, "Sender.cer", "Sender.pub"); 


    //     .
    if(CryptGetUserKey(
	hProv, 
	AT_KEYEXCHANGE, 
	&hKey)) 
    {
	printf("The private key has been acquired. \n");
    }
    else
    {
	HandleError("Error during CryptGetUserKey private key.");
    }

    //        
    //    .
    if(CryptImportKey(
	hProv, 
	pbKeyBlob, 
	dwBlobLen, 
	hKey, 
	0, 
	&hAgreeKey))
    {
	printf("The sender public key has been imported. \n");
    }
    else
    {
	HandleError("Error during CryptImportKey public key.");
    }

    //  PRO12_EXPORT   
    if(CryptSetKeyParam(
        hAgreeKey,
        KP_ALGID,
        (LPBYTE)&ke_alg,
        0))
    {
	printf("PRO12_EXPORT agree key algorithm has been set. \n");
    }
    else
    {
	HandleError("Error during CryptSetKeyParam agree key.");
    }

    //-----------------------------------------------------------------
    //    
    //-----------------------------------------------------------------
    //    -    8  
    //  .
    if(!CryptSetKeyParam(
	hAgreeKey, 
	KP_SV, 	
	pbIV, 
	0))
    {
	HandleError("Error during CryptSetKeyParam.");
    }
    printf( "CryptSetKeyParam succeeded. \n");


    //        
    //   Agree    
    if(CryptImportKey(
	hProvCopy, 
	pbKeyBlobExport, 
	dwKeyBlobExportLen, 
	hAgreeKey, 
	0, 
	&hKeyExport))
    {
	printf("The private Key has been imported. \n");
    }
    else
    {
	HandleError("Error during CryptImportKey private Key.");
    }


    CleanUp();

    printf("The program ran to completion without error. \n");    

    free(pbKeyBlobExport);


    return 0;

}//  main



//  PUBLICKEYBLOB  ,   , () 
//  ,   .
void LoadPublicKey(BYTE *pbBlob, DWORD *pcbBlob, char *szCertFile, char *szKeyFile)
{
    //  ,      .
    if((certf = fopen(szCertFile, "rb"))) 
    {
	DWORD cbCert = 2000;
	BYTE  pbCert[2000];
	PCCERT_CONTEXT pCertContext = NULL;
	HCRYPTKEY hPubKey;
	printf( "The file '%s' was opened\n", szCertFile );

	cbCert = (DWORD)fread(pbCert, 1, cbCert, certf);
	if(!cbCert)
	    HandleError( "Failed to read certificate\n" );
	printf( "Certificate was read from the '%s'\n", szCertFile );

	pCertContext = CertCreateCertificateContext (
	    X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, pbCert, cbCert);
	if (!pCertContext)
	{
	    HandleError( "CertCreateCertificateContext" );
	}

	//   
	if (CryptImportPublicKeyInfoEx(
	    hProv, 
	    X509_ASN_ENCODING | PKCS_7_ASN_ENCODING,
	    &(pCertContext->pCertInfo->SubjectPublicKeyInfo),
	    0,
	    0,
	    NULL,
	    &hPubKey))
	{
	    printf("Public key imported from cert file\n");
	} 
	else 
	{
	    CertFreeCertificateContext(pCertContext);
	    HandleError( "CryptImportPublicKeyInfoEx" );
	}
	CertFreeCertificateContext(pCertContext);

	//    BLOB
	if (CryptExportKey(
	    hPubKey,
	    0,
	    PUBLICKEYBLOB,
	    0,
	    pbBlob,
	    pcbBlob))
	{
	    printf("Public key exported to blob\n");
	}
	else
	{
	    HandleError( "CryptExportKey" );
	}
    } else 
    {
	//  ,      .
	if(!(publicf = fopen(szKeyFile, "rb")))
	    HandleError( "Problem opening the public key blob file\n" );
	printf( "The file '%s' was opened\n", szKeyFile );

	*pcbBlob = (DWORD)fread(pbBlob, 1, *pcbBlob, publicf);
	if(!*pcbBlob)
	    HandleError( "Failed to read key blob file\n" );
	printf( "Key blob was read from the '%s'\n", szKeyFile );
    }
}


  
void CleanUp(void)
{
    if (EncryptedKeyBlob)
	fclose (EncryptedKeyBlob);
    if(vectorf)    
        fclose (vectorf);
    if(certf)
	fclose (certf);
    if(publicf)
	fclose (publicf);


    //    .
    if(hKey)
	CryptDestroyKey(hKey);

    //    .
    if(hKeyExport)
	CryptDestroyKey(hKeyExport);

    //    .
    if(hAgreeKey)
	CryptDestroyKey(hAgreeKey);

    //   .
    if(hProv) 
	CryptReleaseContext(hProv, 0);

    //   .
    if(hProvCopy) 
	CryptReleaseContext(hProvCopy, 0);
}

//   
// (    ,   
//     )

//--------------------------------------------------------------------
//       HandleError,  
//   ,       . 
//         , 
//        .

void HandleError(char *s)
{
    DWORD err = GetLastError();
    printf("Error number     : 0x%x\n", err);
    printf("Error description: %s\n", s);
    CleanUp();
    if(!err) err = 1;
    exit(err);
}

