#include <stdio.h>
#include <string.h>
#ifdef _WIN32
#   include <windows.h>
#   include <wincrypt.h>
#else
#   include <stdlib.h>
#   include <CSP_WinDef.h>
#   include <CSP_WinCrypt.h>
#endif
#include <WinCryptEx.h>

//   (    ,   
//    )
//--------------------------------------------------------------------
//        AT_KEYEXCHANGE 
//    .
//
//        
//      "Responder.pub"  
//  ExportInFile.       
//   .      :
//   "Responder.pub"   "Responder.cer".
//
//    ,   "Sender"  "Responder", 
//    ExportInFile, EncryptKey  DecryptKey  
//    .
//--------------------------------------------------------------------



#pragma region  

#define BLOCK_LENGTH 4096

static void LoadPublicKey(BYTE *pbBlob, DWORD *pcbBlob, char *szCertFile, char *szKeyFile);
static void WriteBlobToFile(FILE *file, BYTE *pbData, DWORD cbData,char *FName);//!!!!!!!!!!!!!!!
static void HandleError(char *s);
static void CleanUp(void);


static HCRYPTPROV hProv = 0;		//  CSP 
static HCRYPTKEY hKey = 0;		//    
static HCRYPTKEY hKeyExport = 0;        //      AT_EXCHANGE
static HCRYPTKEY hAgreeKey = 0;         //   

static FILE *certf=NULL;		// ,    
static FILE *publicf=NULL;		// ,     
static FILE *vectorf = NULL;		//       
static FILE *EncryptedKeyBlob = NULL;   //       

static BYTE *pbKeyBlobExport = NULL;    //    BLOB     AT_EXCHANGE
static BYTE *pbIV = NULL;		//    



#pragma endregion

#define MAX_PUBLICKEYBLOB_SIZE 200

int main(void)
{
    BYTE  pbKeyBlob[MAX_PUBLICKEYBLOB_SIZE];		//    BLOB 
    DWORD dwBlobLen = MAX_PUBLICKEYBLOB_SIZE;		//   BLOB    
    DWORD dwKeyBlobExportLen;		//   BLOB  


    DWORD dwIV = 0;			//   
    ALG_ID ke_alg = CALG_PRO12_EXPORT;	//   


    

    //       "Sender" 
    if(CryptAcquireContext(
	&hProv, 
	"Sender", 
	NULL, 
	PROV_GOST_2012_256, 
	0)) 
    {
	printf("The key container \"Sender\" has been acquired. \n");
    }
    else
    {
	HandleError("Error during CryptAcquireContext.");
    }

    //----------------------------------------------------------------------------
    //   
    //----------------------------------------------------------------------------    
    //    
    LoadPublicKey(pbKeyBlob, &dwBlobLen, "Responder.cer", "Responder.pub");


    //     .
    if(CryptGetUserKey(
	hProv, 
	AT_KEYEXCHANGE, 
	&hKey)) 
    {	printf("The private key has been acquired. \n");
    }
    else
    {
	HandleError("Error during CryptGetUserKey private key.");
    }

    //       
    //    .
    if(CryptImportKey(
	hProv,  
	pbKeyBlob, 
	dwBlobLen, 
	hKey, 
	0, 
	&hAgreeKey))
    {
	printf("The responder public key has been imported. \n");
    }
    else
    {
	HandleError("Error during CryptImportKey public key.");
    }

    //  PRO12_EXPORT   
    if(CryptSetKeyParam(
        hAgreeKey,
        KP_ALGID,
        (LPBYTE)&ke_alg,
        0))
    {
	printf("PRO12_EXPORT agree key algorithm has been set. \n");
    }
    else
    {
	HandleError("Error during CryptSetKeyParam agree key.");
    }

    //--------------------------------------------------------------------
    //   .
    //--------------------------------------------------------------------
    //    ,   .
    if(CryptGetUserKey( 
	hProv, 
	AT_KEYEXCHANGE, 
	&hKeyExport )) 
    {
	printf("The sender private key has been acquired. \n");
    }
    else
    {
	HandleError("Error during CryptGetUserKey private key.");
    }

    //--------------------------------------------------------------------
    //     . 
    if(CryptGetKeyParam(
	hAgreeKey, 
	KP_SV, 
	NULL, 
	&dwIV, 
	0))
    {
	printf("Size of the IV for the sender secret Key determined. \n");
    }
    else
    {
	HandleError("Error computing IV length.");

    }

    pbIV = (BYTE*)malloc(dwIV);
    if (!pbIV)
	HandleError("Out of memory. \n");

    //    .
    if(CryptGetKeyParam(
	hAgreeKey, 
	KP_IV, 
	pbIV, 
	&dwIV, 
	0))
    {
	printf( "CryptGetKeyParam succeeded. \n");
    }
    else
    {
	HandleError("Error during CryptGetKeyParam.");
    }
    
    //     .
    WriteBlobToFile(vectorf, pbIV, dwIV, "vector.bin"); 

    //--------------------------------------------------------------------
    //   BLOB    .   
    
    if(CryptExportKey(
	hKeyExport, 
	hAgreeKey, 
	PRIVATEKEYBLOB, 
	0, 
	NULL,
	&dwKeyBlobExportLen)) 
    {
	printf("Size of the BLOB for the sender secret Key determined. \n");
    }
    else
    {
	HandleError("Error computing BLOB length.");
    }

    pbKeyBlobExport = (BYTE*)malloc(dwKeyBlobExportLen);

    if(!pbKeyBlobExport) 
	HandleError("Out of memory. \n");

    //     Agree.

    if(CryptExportKey(
	hKeyExport, 
	hAgreeKey, 
	PRIVATEKEYBLOB,
	0, 
	pbKeyBlobExport, 
	&dwKeyBlobExportLen))
    {
	printf("Contents have been written to the BLOB. \n");
    }
    else
    {
	HandleError("Error during CryptExportKey.");
    }


    //    
    WriteBlobToFile(EncryptedKeyBlob, pbKeyBlobExport, dwKeyBlobExportLen, "EncryptedKeyBlob.enc");    
    return 0;
}



//  PUBLICKEYBLOB  ,   , () 
//  ,   .
void LoadPublicKey(BYTE *pbBlob, DWORD *pcbBlob, char *szCertFile, char *szKeyFile)
{
    //  ,      .
    if((certf = fopen(szCertFile, "rb"))) 
    {
	DWORD cbCert = 2000;
	BYTE  pbCert[2000];
	PCCERT_CONTEXT pCertContext = NULL;
	HCRYPTKEY hPubKey;
	printf( "The file '%s' was opened\n", szCertFile );

	cbCert = (DWORD)fread(pbCert, 1, cbCert, certf);
	if(!cbCert)
	    HandleError( "Failed to read certificate\n" );
	printf( "Certificate was read from the '%s'\n", szCertFile );

	pCertContext = CertCreateCertificateContext (
	    X509_ASN_ENCODING | PKCS_7_ASN_ENCODING, pbCert, cbCert);
	if (!pCertContext) 
	{
	    HandleError( "CertCreateCertificateContext" );
	}

	//   
	if (CryptImportPublicKeyInfoEx(
	    hProv, 
	    X509_ASN_ENCODING | PKCS_7_ASN_ENCODING,
	    &(pCertContext->pCertInfo->SubjectPublicKeyInfo),
	    0,
	    0,
	    NULL,
	    &hPubKey))
	{
	    printf("Public key imported from cert file\n");
	} 
	else 
	{
	    CertFreeCertificateContext(pCertContext);
	    HandleError( "CryptImportPublicKeyInfoEx" );
	}
	CertFreeCertificateContext(pCertContext);
	
	//    BLOB
	if (CryptExportKey(
	    hPubKey,
	    0,
	    PUBLICKEYBLOB,
	    0,
	    pbBlob,
	    pcbBlob))
	{
	    printf("Public key exported to blob\n");
	}
	else
	{
	    HandleError( "CryptExportKey" );
	}
    } else 
    {
	//  ,      .
	if(!(publicf = fopen(szKeyFile, "rb")))
	    HandleError( "Problem opening the public key blob file\n" );
	printf( "The file '%s' was opened\n", szKeyFile );

	*pcbBlob = (DWORD)fread(pbBlob, 1, *pcbBlob, publicf);
	if(!*pcbBlob)
	    HandleError( "Failed to read key blob file\n" );
	printf( "Key blob was read from the '%s'\n", szKeyFile );
    }
}


void WriteBlobToFile(FILE *file, BYTE *pbData, DWORD cbData, char *FName )
{
    //       BLOB-
    if((file = fopen(FName, "wb")))
    {
	printf("The file '%s' was opened\n", FName);
    }
    else
    {
	HandleError("Problem opening the file\n");
    }

    //  BLOB-  
    if(fwrite(pbData, 1, cbData, file))
    {
	printf("The blob was written to the '%s'\n", FName);
    }
    else
    {
	HandleError("The blob can not be written to file.");
    }
}


void CleanUp(void)
{
    if(vectorf)
	fclose (vectorf);
    if(publicf)
	fclose (publicf);    
    if(EncryptedKeyBlob)
	fclose (EncryptedKeyBlob);
    if(certf)
	fclose (certf);



    //    .
    if(hKey)
	CryptDestroyKey(hKey);

    //    .
    if(hKeyExport)
	CryptDestroyKey(hKeyExport);

    //    .
    if(hAgreeKey)
	CryptDestroyKey(hAgreeKey);

    //   .
    if(hProv) 
	CryptReleaseContext(hProv, 0);

    if(pbKeyBlobExport)
	free(pbKeyBlobExport);
    if(pbIV)
	free(pbIV);

}


//   
// (    ,   
//     )

//--------------------------------------------------------------------
//       HandleError,  
//   ,       . 
//         , 
//        .


void HandleError(char *s)
{
    DWORD err = GetLastError();
    printf("Error number     : 0x%x\n", err);
    printf("Error description: %s\n", s);
    CleanUp();
    if(!err) err = 1;
    exit(err);
}
