/*
 * Copyright(C) 2003  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 126987 $
 * \date $Date:: 2015-09-08 17:51:58 +0400#$
 * \author $Author: pav $
 *
 * \brief PKIXCMP_Server class
 */

#ifndef PKIXCMP_CONWND_H
#define PKIXCMP_CONWND_H

#include "PKIXCMP_Server.h"

class ConsoleWndProv : public WndProv {
public:
    bool insert_create( const char *name, unsigned long error, short n, int num );
    bool retry( const char *name, int num, Retry &retry );
    bool get_current_pin( const char *name, short i, char pin[9], short n, int num );
    bool get_new_pin( const char *name, char pin[9], short n, int num );
    int get_key_size( );
    std::string get_reader( const ReaderList& );
};
extern ConsoleWndProv con_wnd_prov;

class SilentWndProv : public WndProv {
public:
    bool insert_create( const char *name, unsigned long error, short n, int num );
    bool retry( const char *name, int num, Retry &retry );
    bool get_current_pin( const char *name, short i, char pin[9], short n, int num );
    bool get_new_pin( const char *name, char pin[9], short n, int num );
    int get_key_size( );
    std::string get_reader( const ReaderList& );
    bool force_new_pin();
};
extern SilentWndProv silent_wnd_prov;

class NoPinWndProv : public SilentWndProv {
    bool get_current_pin( const char *name, short i, char pin[9], short n, int num );
    bool get_new_pin( const char *name, char pin[9], short n, int num );
    virtual bool no_pin();
}; 

extern NoPinWndProv no_pin_wnd_prov;
extern WIN32WndProv w32_wnd_prov;

#endif //PKIXCMP_CONWND_H
