/*
 * Copyright(C) 2008  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 126987 $
 * \date $Date:: 2015-09-08 17:51:58 +0400#$
 * \author $Author: pav $
 * \brief     (RDR_FKC).
 */

#if !defined( _READER_FKC_H )
#define _READER_FKC_H

#include "reader/rdr_fkc.h"
#include "reader.kit/reader.h"

/*      . 0x23xx */
#define READER_FUN_FOLDER_PARAM_GET 0x2307
#define READER_FUN_FOLDER_PARAM_SET 0x2308
#define READER_FUN_AUTH_TYPE 0x2309
/*       0x33xx */
#define READER_FUN_FOLDER_OPEN_EX 0x3308
#define READER_FUN_UEC_SET_PIN1 0x330A
#define READER_FUN_UEC_OPEN_DATA 0x330B
#define READER_FUN_UEC_CLOSE_DATA 0x330C
#define READER_FUN_UEC_READ_DATA 0x330D
#define READER_FUN_UEC_WRITE_DATA 0x330E
#define READER_FUN_UEC_CHANGE_PIN1 0x330F
#define READER_FUN_RANDOM_GET 0x3310
/*       . 0x43xx */
/*     . 0x53xx */
#define READER_FUN_AUTH_CHALLENGE 0x5304
#define READER_FUN_PUK_AUTH_CHALLENGE 0x5306
/*    . 0x63xx */
#define READER_FUN_AUTH_CHANGE 0x6305
#define READER_FUN_FRIENDLY_NAME_SET 0x6306	// TODO: doc
/*     . 0x73xx */
#define READER_FUN_KEY_GEN 0x7304
#define READER_FUN_KEY_SET 0x7305
#define READER_FUN_AUTH_SET 0x7306
#define READER_FUN_SIGNATURE 0x7307
#define READER_FUN_AGREEMENT 0x7308
#define READER_FUN_AGREEMENT_MASK 0x730B
#define READER_FUN_AGREEMENT_FULL 0x730C
#if _DEBUG
#define READER_FUN_SIGNATURE_DEBUG 0x7309
#endif /*_DEBUG*/
#define READER_FUN_SIGNATURE_HASH 0x730A

#ifdef READER_FUN_FOLDER_PARAM_GET	    // TODO: doc
typedef struct TReaderInfoFolderParamGet_	    // TODO: doc
{
    size_t size_of;
    TRdrFolderEnumParam paramID;
    TRdrFolderParamValue *paramValue;
    size_t paramSize;
} TReaderInfoFolderParamGet;
#else
#   error READER_FUN_FOLDER_PARAM_GET & TReaderInfoFolderParamGet
#endif

#ifdef READER_FUN_FOLDER_PARAM_SET	    // TODO: doc
typedef struct TReaderInfoFolderParamSet_	    // TODO: doc
{
    size_t size_of;
    const TRdrFolderParamValue *paramValue;
} TReaderInfoFolderParamSet;
#else
#   error READER_FUN_FOLDER_PARAM_SET & TReaderInfoFolderParamSet
#endif

#ifdef READER_FUN_AUTH_TYPE

/*!
 * \ingroup reader_interface_fkc
 * \defgroup reader_interface_fkc_param     
 * \brief      
 *
 *           . 
 */


/*! \ingroup reader_interface_fkc_param
 * \def READER_FUN_FOLDER_PARAM_GET
 * \brief    .  \ref rdr_folder_get_param .      ,   rdr_folder_get_param.
 *      .  ,         (   -  NULL-),  
 *     ,         .      
 *  ,        ,   ,        (  
 *    ).
 *
 * \sa #rdr_folder_get_param
 * \return \ref RDR_ERR_FKC_NEED_ROOT_AUTH          NULL-, 
 *        .
 * \return \ref RDR_ERR_FKC_NEED_CONT_AUTH         ,      .
 * \return \ref SUP_ERR_NO     .
 * \return        \ref rdr_ext_error ,   ,   .
 * \req_suprdr
 */

/*! \ingroup reader_interface_fkc_param
 * \def READER_FUN_FOLDER_PARAM_SET
 * \brief    .  \ref rdr_folder_set_param .      ,   rdr_folder_set_param.
 *
 * \sa #rdr_folder_set_param
 * \return \ref RDR_ERR_FKC_NEED_ROOT_AUTH          NULL-, 
 *        .
 * \return \ref RDR_ERR_FKC_NEED_CONT_AUTH         ,      .
 * \return \ref SUP_ERR_NO     .
 * \return        \ref rdr_ext_error ,   ,   .
 * \req_suprdr
 */

/*! \ingroup reader_interface_fkc_param
 * \def READER_FUN_FRIENDLY_NAME_SET
 * \brief    .  \ref rdr_friendly_name_set
 *
 * \sa #rdr_friendly_name_set
 * \return \ref RDR_ERR_FKC_NEED_ROOT_AUTH          NULL-,    .
 * \return \ref RDR_ERR_FKC_NEED_CONT_AUTH       .
 * \return \ref SUP_ERR_NO     .
 * \return        \ref rdr_ext_error ,   ,   .
 * \req_suprdr
 */


/*! \ingroup reader_interface_chl_fun
 * \def READER_FUN_AUTH_TYPE
 * \brief       ,      .
 * \return \ref SUP_ERR_NO    .
 * \return        \ref rdr_ext_error ,   ,   .
 *
 * \sa #TReaderInfoAuthType_, #rdr_auth_type
 * \req_suprdr
 */

/*! \ingroup reader_interface_chl_struct
 * \brief     
 * \req_suprdr
 */
typedef struct TReaderInfoAuthType_
{
    size_t size_of;		//!<   
    TRdrInfoAuthType *authType;	//!< [out]   authSize
    size_t authSize;		//!< [in/out]   authType
} TReaderInfoAuthType;
#else
#   error READER_FUN_AUTH_TYPE & TReaderInfoAuthType
#endif

#ifdef READER_FUN_FOLDER_OPEN_EX
/*! \ingroup reader_interface_fkc_fld_fun
 * \def READER_FUN_FOLDER_OPEN_EX
 * \brief      .
 *
 *   #READER_FUN_FOLDER_OPEN    .  folderParam == NULL 
 *     .        .
 * 
 * \return \ref RDR_ERR_FKC_NEED_ROOT_AUTH      -NULL-      
 * NULL-,    .
 * \return \ref SUP_ERR_NO     .
 * \return        \ref rdr_ext_error ,   ,   .
 *
 * \sa #TReaderInfoFolderOpenEx_, #READER_FUN_FOLDER_OPEN, #rdr_folder_open_ex, #TRdrInfoFolderOpenEx_param
 * \req_suprdr
 */

/*! \ingroup reader_interface_fkc_struct
 * \brief       
 * \req_suprdr
 */
typedef struct TReaderInfoFolderOpenEx_
{
    size_t size_of;		//!<   
    TSupSysInfoText name;	//!<     
    size_t mode_bits;		//!<    0  1    mode
				//!<    #READER_MODEFLAG_BITS.
    TReaderInfoOpenFlags *mode;	//!<      . 
				//!<  : o_creat -   ,  
			    	//!<  ,  ,    .
    const TRdrInfoFolderOpenEx_param *folderParam; 
    				//!< ,   
} TReaderInfoFolderOpenEx;

MAKE_CONVERSION_FUNCTIONS(TReaderInfoFolderOpenEx, TReaderInfoFolderOpen, MCF_CHECK_size_of)
	/* TODO: borodin  ???? */

#else
#   error READER_FUN_FOLDER_OPEN_EX & TReaderInfoFolderOpenEx
#endif

#ifdef READER_FUN_AUTH_CHALLENGE
/*! \ingroup reader_interface_chl_fun
 * \def READER_FUN_AUTH_CHALLENGE
 * \brief     .
 *
 * \sa #TReaderInfoAuthChallenge_, #rdr_auth_challenge, #rdr_auth_type
 * \return \ref RDR_ERR_FKC_NEED_ROOT_AUTH          NULL-,    .
 * \return \ref RDR_ERR_FKC_NEED_CONT_AUTH        .
 * \return \ref RDR_ERR_FKC_TRANSACTION   ,    .
 * \return \ref RDR_ERR_INVALID_PASSWD   .
 * \return \ref RDR_ERR_INVALID_PASSWD_FORMAT     .
 * \return \ref RDR_ERR_FKC_OPLIMIT_REACHED  ,        EKE (   EKE).   ,           .
 * \return \ref RDR_ERR_PASSWD_LOCKED   ,      (     EKE). 
 *   ,           .
 *   ,     \ref RDR_ERR_INVALID_PASSWD.
 * \return \ref RDR_ERR_BLOCK     ,      (/   ), 
 *   .
 * \return \ref SUP_ERR_NO           (/   ).
 * \return        \ref rdr_ext_error ,   ,   .
 * \req_suprdr
 */

/*! \ingroup reader_interface_chl_struct
 * \brief     Challenge/Responce
 * \sa #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_type
 * \req_suprdr
 */
typedef struct TReaderInfoAuthChallenge_ {
    size_t size_of;		    //!<   
    TRdrLoginInfoType type;	    //!<     ,   
    TRdrChallenge_class Class;	    //!<  
    TRdrChallenge_id id;	    //!<  
    const TRdrChallenge2folder *toFolder;
    				    //!<   CSP  
    TRdrChallenge2rdr *fromFolder;  //!<     CSP
} TReaderInfoAuthChallenge;
#else
#   error READER_FUN_AUTH_CHALLENGE & TReaderInfoAuthChallenge
#endif

#ifdef READER_FUN_AUTH_CHANGE
/*! \ingroup reader_interface_chl_fun
 * \def READER_FUN_AUTH_CHANGE
 * \brief     .
 *
 * \sa #TReaderInfoAuthChange_, #rdr_auth_change, #rdr_auth_type
 * \return \ref RDR_ERR_FKC_NEED_ROOT_AUTH          NULL-,    .
 * \return \ref RDR_ERR_FKC_NEED_CONT_AUTH        .
 * \return \ref RDR_ERR_FKC_OPLIMIT_REACHED  ,        EKE (   EKE).   ,           .
 * \return \ref RDR_ERR_FKC_TRANSACTION   ,    .
 * \return \ref RDR_ERR_BLOCK     ,   ,  .
 * \return \ref SUP_ERR_NO        .
 * \return        \ref rdr_ext_error ,   ,   .
 * \req_suprdr
 */

/*! \ingroup reader_interface_chl_struct
 * \brief     Challenge/Responce
 * \sa #TReaderInfoAuthChallenge_, #rdr_auth_change, #rdr_auth_type
 * \req_suprdr
 */
typedef struct TReaderInfoAuthChange_ {
    size_t size_of;		    //!<   
    TRdrLoginInfoType type;	    //!<       
    TRdrChallenge_class Class;	    //!<  
    TRdrChallenge_id id;	    //!<  
    const TRdrChallenge2folder *toFolder;
    				    //!<   CSP  
    TRdrChallenge2rdr *fromFolder;  //!<     CSP
} TReaderInfoAuthChange;
#else
#   error READER_FUN_AUTH_CHANGE & TReaderInfoAuthChange
#endif


/*!
 * \ingroup reader_interface_fkc
 * \defgroup reader_interface_fkc_crypt   
 * \brief   ,    .
 *
 *  ,     , 
 *         
 *   .
 */

/*!         
 * \ingroup reader_interface_fkc_crypt
 * \defgroup reader_interface_fkc_fun   
 * 
 */

/*!
 * \ingroup reader_interface_fkc_crypt
 * \defgroup reader_interface_fkc_struct    
 */
#ifdef READER_FUN_KEY_GEN
/*! \ingroup reader_interface_fkc_fun
 * \def READER_FUN_KEY_GEN
 * \brief     
 *
 *     ,  
 *     EKE / PIN.
 *
 * \sa #TReaderFkcKeyGen_
 * \return \ref RDR_ERR_FKC_NEED_ROOT_AUTH          NULL-,    .
 * \return \ref SUP_ERR_NO     .
 * \return        \ref rdr_ext_error ,   ,   .
 * \req_suprdr
 */

/*! \ingroup reader_interface_fkc_struct
 * \brief       
 * \req_suprdr
 */
typedef struct TReaderFkcKeyGen_ 
{
    size_t size_of;		//!<    TReaderFkcKeyGen_
    const TRdrFkcPoint *uQs;	//!<  -  EKE (   EKE)
    const TRdrFkcPoint *uQpw;	//!<  -   EKE (   )
    const TCHAR *tPIN;		//!<  PIN  
    BYTE *pubKey;		//!<   ,   
} TReaderFkcKeyGen;
#else
#   error READER_FUN_KEY_GEN & TReaderFkcKeyGen
#endif

#ifdef READER_FUN_KEY_SET
/*! \ingroup reader_interface_fkc_fun
 * \def READER_FUN_KEY_SET
 * \brief     
 *
 *     ,  
 *     EKE / PIN.
 *
 * \sa #TReaderFkcKeySet_
 * \return \ref RDR_ERR_FKC_NEED_ROOT_AUTH          NULL-,    .
 * \return \ref SUP_ERR_NO     .
 * \return        \ref rdr_ext_error ,   ,   .
 * \req_suprdr
 */

/*! \ingroup reader_interface_fkc_struct
 * \brief       
 * \req_suprdr
 */
typedef struct TReaderFkcKeySet_ 
{
    size_t size_of;		 //!<    TReaderFkcKeySet_
    const TRdrFkcPoint *uQs;	 //!<  -  EKE (   EKE)
    const TRdrFkcPoint *uQpw;	 //!<  -   EKE (   )
    const TRdrFkcOrder *udfkc;	 //!<   ,         
    const TRdrFkcSyncro *usyncro;//!<    CSP
    const TCHAR *tPIN;		 //!<  PIN  
} TReaderFkcKeySet;

/*! \ingroup reader_interface_fkc_fun
 * \def READER_FUN_AUTH_SET
 * \brief     
 *
 *      ,   d_fkc
 *
 * \sa #TReaderFkcAuthSet_
 * \return \ref RDR_ERR_FKC_NEED_ROOT_AUTH        .
 * \return \ref SUP_ERR_NO     .
 * \return        \ref rdr_ext_error ,   ,   .
 * \req_suprdr
 */

/*! \ingroup reader_interface_fkc_struct
 * \brief       
 * \req_suprdr
 */
typedef struct TReaderFkcAuthSet_ 
{
    size_t size_of;		 //!<    TReaderFkcAuthSet_
    const TRdrFkcPoint *uQs;	 //!<  -  EKE (   EKE)
    const TRdrFkcPoint *uQpw;	 //!<  -   EKE (   )
    const TRdrFkcSyncro *usyncro;//!<    CSP
} TReaderFkcAuthSet;
#else
#   error READER_FUN_KEY_SET & TReaderFkcKeySet
#endif

#ifdef READER_FUN_SIGNATURE
/*! \ingroup reader_interface_fkc_fun
 * \def READER_FUN_SIGNATURE
 * \brief     
 *
 *   
 *
 * \sa #TReaderFkcSignInfo_, #TfkcSignInfo_id
 * \return \ref RDR_ERR_FKC_NEED_ROOT_AUTH          NULL-,    .
 * \return \ref RDR_ERR_FKC_NEED_CONT_AUTH       .
 * \return \ref RDR_ERR_FKC_TRANSACTION   ,    .
 * \return \ref RDR_ERR_FKC_OPLIMIT_REACHED  ,         (   ).   ,           .
 * \return \ref RDR_ERR_BLOCK      . 
 * \return \ref SUP_ERR_NO      .
 * \return        \ref rdr_ext_error ,   ,   .
 * \req_suprdr
 */

/*! \ingroup reader_interface_fkc_struct
 * \brief   
 * \req_suprdr
 */
enum TfkcSignInfo_id {
    TRECi_first = 1,	//!<   
    TRECi_second = 2,	//!<   
    TRECi_first_hash = 3//!<     
}; 

/*! \ingroup reader_interface_fkc_struct
 * \brief /  
 * \sa #rdr_crypt_signature_1, #rdr_crypt_signature_2
 * \req_suprdr
 */
typedef struct TReaderFkcSignInfo_
{
    size_t size_of;		    //!<    TReaderFkcKeyGen_
    enum TfkcSignInfo_id id;	    //!<   
    union {
	struct {
	    const TRdrFkcOrder *e;  //!< -
    	    TRdrFkcTrID	TrId; //!<  
	    TRdrFkcTrNewID IsNewTr; //!<   
	} first;
	struct {
	    const TRdrFkcOrder *ur; //!<  
    	    TRdrFkcTrID	TrId; //!<  
	} second;
	struct {
	    const TSupSysEContext * handle;  //!<  
    	    TRdrFkcTrID	TrId; //!<  
	    TRdrFkcTrNewID IsNewTr; //!<   
	} first_hash;
    } toFKC;
    union {
	struct {
	    TRdrFkcPoint *uR2;	    //!<  
	} first;
	struct {
	    TRdrFkcOrder *us2;	    //!<    
	} second;
    } fromFKC;
    struct {
	unsigned char * hash;
	unsigned long hash_len;
	unsigned char * signature;
	unsigned long signature_len;
    } UEC;
} TReaderFkcSignInfo;

/*   - */

typedef struct TReaderInfoUECReadData_
{
    size_t size_of;
    size_t read_param;  
    size_t from;
    size_t read_tag;
    unsigned int is_binary;
    TSupSysInfoUntyped info;
} TReaderInfoUECReadData;

typedef struct TReaderInfoUECWriteData_
{
    size_t size_of;
    size_t write_param;  
    size_t from;
    unsigned int is_binary;
    TSupSysInfoUntyped info;
} TReaderInfoUECWriteData;

typedef struct TReaderInfoLogin_ TReaderInfoUECPin1;

typedef struct TReaderInfoUECOpenData_
{
    size_t size_of;
    TRdrFileNumber num;
} TReaderInfoUECOpenData;

# if _DEBUG
/*! \ingroup reader_interface_fkc_struct
 * \brief /  ,  
 * \sa #rdr_crypt_signature_1, #rdr_crypt_signature_2
 * \req_suprdr
 */
typedef struct TReaderFkcSignInfo_Debug_
{
    size_t size_of;		    //!<    TReaderFkcKeyGen_
    enum TfkcSignInfo_id id;	    //!<   
    union {
	struct {
	    const TRdrFkcOrder *e;  //!< -
	    const TRdrFkcOrder *k2;  //!< -
    	    TRdrFkcTrID	TrId; //!<  
	    TRdrFkcTrNewID IsNewTr; //!<   
	} first;
	struct {
	    const TRdrFkcOrder *ur; //!<  
    	    TRdrFkcTrID	TrId; //!<  
	} second;

    } toFKC;
    union {
	struct {
	    TRdrFkcPoint *uR2;	    //!<  
	} first;
	struct {
	    TRdrFkcOrder *us2;	    //!<    
	} second;
    } fromFKC;
} TReaderFkcSignInfo_Debug;
# endif /*_DEBUG*/

#else
#   error READER_FUN_SIGNATURE & TReaderFkcSignInfo
#endif

#ifdef READER_FUN_AGREEMENT
/*! \ingroup reader_interface_fkc_fun
 * \def READER_FUN_AGREEMENT
 * \brief     
 *
 *    
 *
 * \sa  #rdr_crypt_agreement_1
 * \return \ref RDR_ERR_FKC_NEED_ROOT_AUTH          NULL-,    .
 * \return \ref RDR_ERR_FKC_NEED_CONT_AUTH       .
 * \return \ref RDR_ERR_FKC_TRANSACTION   ,    .
 * \return \ref RDR_ERR_FKC_OPLIMIT_REACHED  ,        - (   -).   ,           .
 * \return \ref SUP_ERR_NO    .
 * \return        \ref rdr_ext_error ,   ,   .
 * \req_suprdr
 */

/*! \ingroup reader_interface_fkc_struct
 * \brief /   
 * \req_suprdr
 */
typedef struct TReaderFkcAgreeInfo_
{
    size_t size_of;		    //!<    TReaderFkcAgreeInfo_
    struct{
	const TRdrFkcPoint *uQalpha;//!<  
	TRdrFkcTrID	TrId; //!<  
	TRdrFkcTrNewID IsNewTr; //!<   
    } toFKC;
    struct {
	TRdrFkcPoint *uK2;	    //!<   
    } fromFKC;
} TReaderFkcAgreeInfo;

/*! \ingroup reader_interface_fkc_struct
 * \brief /        
 * \req_suprdr
 */
typedef struct TReaderUECAgreeInfo_
{
    size_t size_of;		    //!<    TReaderUECAgreeInfo_
    struct{
	const TRdrFkcPoint *uQalpha; //!< 
    } toFKC;
    struct {
	TRdrFkcPoint *uK2;	    //!<    
	TRdrFkcOrder *mask;	    //!<  
    } fromFKC;
} TReaderUECAgreeInfo;

/*! \ingroup reader_interface_fkc_struct
 * \brief /        
 * \req_suprdr
 */
typedef struct TReaderAgreeInfo_
{
    size_t size_of;		    //!<    TReaderAgreeInfo_
    struct{
	const TRdrFkcPoint *uQalpha; //!< ,  
	const TRdrFkcUKM * ukm;	    //!< UKM
    } toFKC;
    struct {
	TRdrFkcOrder *key;	    //!<  
    } fromFKC;
} TReaderAgreeInfo;

#else
#   error READER_FUN_AGREEMENT & TReaderFkcAgreeInfo
#endif
#endif /* !defined( _READER_FKC_H ) */
/* end of file: $Id: reader_fkc.h 126987 2015-09-08 13:51:58Z pav $ */
