/*
 * Copyright(C) 2008  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 126987 $
 * \date $Date:: 2015-09-08 17:51:58 +0400#$
 * \author $Author: pav $
 * \brief   pin.
 */

#include "ric_prj.h"

/*!
 * \brief   pin.
 */
TSupErr trust_change_pin(
    const TRICContext *ctx, 
    unsigned char pin[8] )
{
    TSupErr code;
    TSCardInfoAPDU apdu_sel = { 0x00, 0xa4, 0x00, 0x0c };
    TSCardInfoAPDU apdu_change = { 0x00, 0x24, 0x01, 0x00 };
    unsigned char data[2] = { 0, 1 };

    /* Select pin file. */
    apdu_sel.input.length = 2;
    apdu_sel.input.info = data;
    apdu_sel.output.length = 0;
    apdu_sel.output.info = NULL;
    code = ctx->apdu( ctx->reader, &apdu_sel );
    if( code )
	return code;
    if( apdu_sel.sw1 != 0x90 || apdu_sel.sw2 != 0x00 )
	return RDR_ERR_INVALID_MEDIA;
    /* change pin */
    apdu_change.input.length = 8;
    apdu_change.input.info = pin;
    apdu_change.output.length = 0;
    apdu_change.output.info = NULL;
    code = ctx->apdu( ctx->reader, &apdu_change );
    if( code )
	return code;
    if( apdu_change.sw1 != 0x90 || apdu_change.sw2 != 0 )
	return ric_error( apdu_change.sw1, apdu_change.sw2 );
    /*   select file,   . */
    if( ctx->file )
    {
	size_t length;
	ric_select_file( ctx, ctx->file, &length );
    }
    return SUP_ERR_NO;
}
/* end of file:$Id: mag_chp.c 126987 2015-09-08 13:51:58Z pav $ */
