/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 126987 $
 * \date $Date:: 2015-09-08 17:51:58 +0400#$
 * \author $Author: pav $
 * \brief    .
 */

#include "ric_prj.h"

static TSupErr get_flen( const TCHAR *path, unsigned char file_id, size_t *len );

/*!
 * \brief    .
 */
TSupErr oscar2_file_length( 
    unsigned char file_id, 
    size_t *length, TCHAR* sconnect )
{
    TCHAR *connect = sconnect ? sconnect : DEFAULT_CONNECT;
    TSupErr err;
    TCHAR *path; 

    if( file_id == 0 || file_id > 6 )
	return SUP_ERR_VERIFY;

    path = malloc((_tcslen(OSCAR2_PATH_CFG) + 
	_tcslen(connect) + _tcslen(BASE_FILE_CFG) + 1) * sizeof(TCHAR));
    if(!path)
	return SUP_ERR_MEMORY;
    _tcscpy( path, OSCAR2_PATH_CFG );
    _tcscat( path, connect );
    _tcscat( path, BASE_FILE_CFG );

    //    
    if( file_id != 3 )
    {
	err = get_flen( path, file_id, length );
	free( path ); 
	if( err ) return err;
	return SUP_ERR_NO;
    }

    //   - ,   ,    
    {
	size_t cur;
	err = get_flen( path, OSCAR2_FILE_NUMBERS[1][0], &cur );
	if( err ) { free( path ); return err; }
	*length -= cur;
    }
    free(path);
    return SUP_ERR_NO;
}

TSupErr get_flen( const TCHAR *path, unsigned char file_id, size_t *len )
{
    long param = 0;
    TCHAR *tst;
    TSupErr code;

    tst = malloc((_tcslen(path) + 3) * sizeof(TCHAR));
    if( !tst )
	return SUP_ERR_MEMORY;
    _sntprintf( tst, _tcslen( path ) + 3, _TEXT( "%s%1d" ), path, file_id );
    code = support_registry_get_long( tst, &param );
    free( tst );
    if( code )
	return code;
    if( param < 0 )
	return SUP_ERR_VERIFY;
    *len = (size_t)param;
    return SUP_ERR_NO;
}

/* end of file: $Id: osc2_flen.c 126987 2015-09-08 13:51:58Z pav $ */
